diff -Naur newlib-1.20.0.orig/ChangeLog newlib-1.20.0/ChangeLog
--- newlib-1.20.0.orig/ChangeLog	2011-12-18 11:20:51.000000000 +0100
+++ newlib-1.20.0/ChangeLog	2012-03-28 10:11:12.180137454 +0200
@@ -1,3 +1,23 @@
+2012-03-09  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* COPYING.NEWLIB: Modify DJ Delorie license to include
+	modification rights in clause as permitted by DJ Delorie.
+	* COPYING.LIBGLOSS: Ditto.
+
+2012-03-09  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* COPYING.NEWLIB: Remove two unused licenses.
+
+2012-03-05  Tristan Gingold  <gingold@adacore.com>
+
+	* configure.ac: Enable gdb and readline for ia64*-*-*vms*.
+	* configure: Regenerate.
+
+2012-02-21  Joern Rennecke  <joern.rennecke@embecosm.com>
+
+	* COPYING.NEWLIB: Add Adapteva notice.
+	* COPYING.LIBGLOSS: Add Adapteva notice.
+
 2011-12-18  Eric Botcazou  <ebotcazou@adacore.com>
 
 	* configure: Regenerate.
diff -Naur newlib-1.20.0.orig/config/ChangeLog newlib-1.20.0/config/ChangeLog
--- newlib-1.20.0.orig/config/ChangeLog	2011-12-19 14:20:23.000000000 +0100
+++ newlib-1.20.0/config/ChangeLog	2012-03-28 10:11:12.181137469 +0200
@@ -1,3 +1,8 @@
+2011-12-20  Andreas Schwab  <schwab@linux-m68k.org>
+
+	* warnings.m4 (ACX_PROG_CC_WARNING_OPTS): Avoid leading dash in
+	expr call.
+
 2011-12-19  Andreas Schwab  <schwab@linux-m68k.org>
 
 	* warnings.m4 (ACX_PROG_CC_WARNING_OPTS)
diff -Naur newlib-1.20.0.orig/config/warnings.m4 newlib-1.20.0/config/warnings.m4
--- newlib-1.20.0.orig/config/warnings.m4	2011-12-19 14:20:23.000000000 +0100
+++ newlib-1.20.0/config/warnings.m4	2012-03-28 10:11:12.181137469 +0200
@@ -32,7 +32,7 @@
   # Do the check with the no- prefix removed since gcc silently
   # accepts any -Wno-* option on purpose
   case $real_option in
-    -Wno-*) option=-W`expr $real_option : '-Wno-\(.*\)'` ;;
+    -Wno-*) option=-W`expr x$real_option : 'x-Wno-\(.*\)'` ;;
     *) option=$real_option ;;
   esac
   AS_VAR_PUSHDEF([acx_Woption], [acx_cv_prog_cc_warning_$option])
diff -Naur newlib-1.20.0.orig/configure.ac newlib-1.20.0/configure.ac
--- newlib-1.20.0.orig/configure.ac	2011-11-09 19:57:28.000000000 +0100
+++ newlib-1.20.0/configure.ac	2012-03-28 10:11:12.187137563 +0200
@@ -929,8 +929,8 @@
     noconfigdirs="$noconfigdirs libgui itcl ld"
     ;;
   ia64*-*-*vms*)
-    # No gdb or ld support yet.
-    noconfigdirs="$noconfigdirs readline libgui itcl gdb ld"
+    # No ld support yet.
+    noconfigdirs="$noconfigdirs libgui itcl ld"
     ;;
   i[[3456789]]86-w64-mingw*)
     ;;
diff -Naur newlib-1.20.0.orig/COPYING.LIBGLOSS newlib-1.20.0/COPYING.LIBGLOSS
--- newlib-1.20.0.orig/COPYING.LIBGLOSS	2011-12-15 23:59:14.000000000 +0100
+++ newlib-1.20.0/COPYING.LIBGLOSS	2012-03-28 10:11:12.174137360 +0200
@@ -51,7 +51,7 @@
 Copyright (C) 1993 DJ Delorie
 All rights reserved.
 
-Redistribution and use in source and binary forms is permitted
+Redistribution, modification,  and use in source and binary forms is permitted
 provided that the above copyright notice and following paragraph are
 duplicated in all such forms.
 
@@ -322,3 +322,29 @@
    the executable file might be covered by the GNU General Public License.
 
 
+(17) - Adapteva, Inc. (epiphany-* targets)
+
+Copyright (c) 2011, Adapteva, Inc.
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are met:
+ * Redistributions of source code must retain the above copyright notice, this
+   list of conditions and the following disclaimer.
+ * Redistributions in binary form must reproduce the above copyright notice,
+   this list of conditions and the following disclaimer in the documentation
+   and/or other materials provided with the distribution.
+ * Neither the name of Adapteva nor the names of its contributors may be used
+   to endorse or promote products derived from this software without specific
+   prior written permission.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
+FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
+CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
diff -Naur newlib-1.20.0.orig/COPYING.NEWLIB newlib-1.20.0/COPYING.NEWLIB
--- newlib-1.20.0.orig/COPYING.NEWLIB	2010-12-02 21:05:11.000000000 +0100
+++ newlib-1.20.0/COPYING.NEWLIB	2012-03-28 10:11:12.175137376 +0200
@@ -117,18 +117,9 @@
 Austin, TX 78741
 800-292-9263
 
-(5) C.W. Sandmann
+(5) 
 
-Copyright (C) 1993 C.W. Sandmann
-
-This file may be freely distributed as long as the author's name remains.
-
-(6) Eric Backus
-
-(C) Copyright 1992 Eric Backus
-
-This software may be used freely so long as this copyright notice is
-left intact.  There is no warrantee on this software.
+(6)
 
 (7) Sun Microsystems
 
@@ -416,7 +407,7 @@
 Copyright (C) 1991 DJ Delorie
 All rights reserved.
 
-Redistribution and use in source and binary forms is permitted
+Redistribution, modification, and use in source and binary forms is permitted
 provided that the above copyright notice and following paragraph are
 duplicated in all such forms.
 
@@ -877,3 +868,29 @@
 the new terms are clearly indicated on the first page of each file where
 they apply. 
 
+(39) - Adapteva, Inc. (epiphany-* targets)
+
+Copyright (c) 2011, Adapteva, Inc.
+All rights reserved.
+
+Redistribution and use in source and binary forms, with or without
+modification, are permitted provided that the following conditions are met:
+ * Redistributions of source code must retain the above copyright notice, this
+   list of conditions and the following disclaimer.
+ * Redistributions in binary form must reproduce the above copyright notice,
+   this list of conditions and the following disclaimer in the documentation
+   and/or other materials provided with the distribution.
+ * Neither the name of Adapteva nor the names of its contributors may be used
+   to endorse or promote products derived from this software without specific
+   prior written permission.
+
+THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
+ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
+FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
+CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
diff -Naur newlib-1.20.0.orig/libgloss/arm/linux-crt0.c newlib-1.20.0/libgloss/arm/linux-crt0.c
--- newlib-1.20.0.orig/libgloss/arm/linux-crt0.c	2011-07-13 17:06:21.000000000 +0200
+++ newlib-1.20.0/libgloss/arm/linux-crt0.c	2012-03-28 10:11:12.190137610 +0200
@@ -18,8 +18,10 @@
 	".global _start\n"
 	".type _start, %function\n"
 	"_start:\n"
-	"\tadr r0, _start_thumb+1\n"
+	"\tldr r0, .LC0\n"
 	"\tbx r0\n"
+	".LC0:\n"
+	"\t.word _start_thumb\n"
 	".size _start, .-_start\n");
 
 __attribute__((naked, used))
diff -Naur newlib-1.20.0.orig/libgloss/bfin/_exit.c newlib-1.20.0/libgloss/bfin/_exit.c
--- newlib-1.20.0.orig/libgloss/bfin/_exit.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/bfin/_exit.c	2012-03-28 10:11:12.191137626 +0200
@@ -0,0 +1,25 @@
+/*
+ * C library support files for the Blackfin processor
+ *
+ * Copyright (C) 2012 Analog Devices, Inc.
+ *
+ * The authors hereby grant permission to use, copy, modify, distribute,
+ * and license this software and its documentation for any purpose, provided
+ * that existing copyright notices are retained in all copies and that this
+ * notice is included verbatim in any distributions. No written agreement,
+ * license, or royalty fee is required for any of the authorized uses.
+ * Modifications to this software may be copyrighted by their authors
+ * and need not follow the licensing terms described here, provided that
+ * the new terms are clearly indicated on the first page of each file where
+ * they apply.
+ */
+
+#include <_ansi.h>
+
+_VOID
+_DEFUN (_exit, (rc),
+	int rc)
+{
+  while (1)
+    asm volatile ("EXCPT 0;");
+}
diff -Naur newlib-1.20.0.orig/libgloss/bfin/include/sys/anomaly_macros_rtl.h newlib-1.20.0/libgloss/bfin/include/sys/anomaly_macros_rtl.h
--- newlib-1.20.0.orig/libgloss/bfin/include/sys/anomaly_macros_rtl.h	2010-10-18 01:52:49.000000000 +0200
+++ newlib-1.20.0/libgloss/bfin/include/sys/anomaly_macros_rtl.h	2012-03-28 10:11:12.191137626 +0200
@@ -12,7 +12,7 @@
 
 /************************************************************************
  *
- * anomaly_macros_rtl.h : $Revision: 1.3 $
+ * anomaly_macros_rtl.h : $Revision$
  *
  * (c) Copyright 2005-2009 Analog Devices, Inc.  All rights reserved.
  *
diff -Naur newlib-1.20.0.orig/libgloss/ChangeLog newlib-1.20.0/libgloss/ChangeLog
--- newlib-1.20.0.orig/libgloss/ChangeLog	2011-12-18 19:41:20.000000000 +0100
+++ newlib-1.20.0/libgloss/ChangeLog	2012-03-28 10:11:12.189137594 +0200
@@ -1,4 +1,52 @@
-2011-12-18  Mike Frysinger  <vapier@gentoo.org>
+2012-03-12  Mike Frysinger  <vapier@gentoo.org>
+
+	* libnosys/Makefile.in (NEWLIB_CFLAGS, NEWLIB_LDFLAGS,
+	INCLUDES, CFLAGS_FOR_TARGET, LDFLAGS_FOR_TARGET,
+	AR_FLAGS, .c.o, .C.o, .s.o, .S.o, .c.s): Delete and replace
+	with @host_makefile_frag@.
+
+2012-03-12  Mike Frysinger  <vapier@gentoo.org>
+
+	* config/default.mh (AR_FLAGS): Set to rc.
+
+2012-03-09  Jeff Johnston  <jjohnstn@redhat.com>
+
+	* epiphany/access.c: Add modification rights to clause as
+	permitted by DJ Delorie.
+	* iq2000/access.c: Ditto.
+	* mn10200/access.c: Ditto.
+	* mn10300/access.c: Ditto.
+	* mt/access.c: Ditto.
+	* v850/access.c: Ditto.
+
+2012-03-02  Bin Cheng  <bin.cheng@arm.com>
+
+	* configure.in: Accept "arm*" target spec instead of just "arm".
+	* configure: Regenerated.
+	* libnosys/configure.in: Likewise.
+	(libc_symbol_prefix): Renamed to libc_cv_symbol_prefix.
+	* libnosys/configure: Regenerated (using autoconf v2.68).
+
+2012-02-21  Jeremy Bennett  <jeremy.bennett@embecosm.com>
+            Alan Lehotsky  <apl@alum.mit.edu>
+            Joern Rennecke  <joern.rennecke@embecosm.com>
+
+	* configure.in: Add Epiphany support.
+	* configure: Regenerate.
+	* epiphany: New directory.
+	* libgloss/README: Add Epiphany entry.
+
+2012-01-23  Stuart Henderson  <stuart.henderson@analog.com>
+
+	* bfin/_exit.c: New file.
+	* bfin/Makefile.in (BOARD_OBJS): Add _exit.o.
+
+2012-01-17  Bin Cheng  <bin.cheng@arm.com>
+
+	* arm/linux-crt0.c: Use ldr instead of adr to get address of
+	_start_thumb.
+
+2011-12-18  Steve Kilbane  <stephen.kilbane@analog.com>
 
 	* bfin/clear_cache_range.c: New file.
 	* bfin/Makefile.in (SIM_OBJS): Add clear_cache_range.o.
diff -Naur newlib-1.20.0.orig/libgloss/config/default.mh newlib-1.20.0/libgloss/config/default.mh
--- newlib-1.20.0.orig/libgloss/config/default.mh	2000-03-17 23:48:49.000000000 +0100
+++ newlib-1.20.0/libgloss/config/default.mh	2012-03-28 10:11:12.192137642 +0200
@@ -6,7 +6,7 @@
 # options are passed; they're passed in $(CFLAGS).
 CFLAGS_FOR_TARGET = -O2 -g ${MULTILIB} ${INCLUDES} ${NEWLIB_CFLAGS}
 LDFLAGS_FOR_TARGET = ${MULTILIB} ${NEWLIB_LDFLAGS}
-AR_FLAGS = qc
+AR_FLAGS = rc
 
 .c.o:
 	$(CC) $(CFLAGS_FOR_TARGET) -O2 $(INCLUDES) -c $(CFLAGS) $<
diff -Naur newlib-1.20.0.orig/libgloss/configure.in newlib-1.20.0/libgloss/configure.in
--- newlib-1.20.0.orig/libgloss/configure.in	2011-12-15 23:58:40.000000000 +0100
+++ newlib-1.20.0/libgloss/configure.in	2012-03-28 10:11:12.193137658 +0200
@@ -34,6 +34,10 @@
 config_libnosys=true
 
 case "${target}" in
+  epiphany-*-*)
+	AC_CONFIG_SUBDIRS(epiphany)
+	config_testsuite=true
+	;;
   i[[3456]]86-*-elf* | i[[3456]]86-*-coff*)
 	AC_CONFIG_SUBDIRS([i386])
 	;;
@@ -58,7 +62,7 @@
   sparclet-*-aout* | sparc-*-elf* | sparc64-*-elf* | sparc86x-*-* | sparclite-*-*)
 	AC_CONFIG_SUBDIRS([sparc])
 	;;
-  sh*-*-pe | mips*-*-pe | *arm-wince-pe)
+  sh*-*-pe | mips*-*-pe | *arm*-wince-pe)
 	AC_CONFIG_SUBDIRS([wince])
 	;;
   mips*-*-*)
@@ -130,7 +134,7 @@
   rx*-*-elf)
 	AC_CONFIG_SUBDIRS([rx])
 	;;
-  arm*-*-elf | arm*-*-coff | arm-*-*)
+  arm*-*-elf | arm*-*-coff | arm*-*-*)
 	AC_CONFIG_SUBDIRS([arm])
 	;;
   spu-*-elf)
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/access.c newlib-1.20.0/libgloss/epiphany/access.c
--- newlib-1.20.0.orig/libgloss/epiphany/access.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/access.c	2012-03-28 10:11:12.195137688 +0200
@@ -0,0 +1,32 @@
+/* This is file ACCESS.C */
+/*
+ * Copyright (C) 1993 DJ Delorie
+ * All rights reserved.
+ *
+ * Redistribution, modification, and use in source and binary forms is permitted
+ * provided that the above copyright notice and following paragraph are
+ * duplicated in all such forms.
+ *
+ * This file is distributed WITHOUT ANY WARRANTY; without even the implied
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+ */
+
+#include <fcntl.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+int access(const char *fn, int flags)
+{
+  struct stat s;
+  if (stat(fn, &s))
+    return -1;
+  if (s.st_mode & S_IFDIR)
+    return 0;
+  if (flags & W_OK)
+  {
+    if (s.st_mode & S_IWRITE)
+      return 0;
+    return -1;
+  }
+  return 0;
+}
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/close.c newlib-1.20.0/libgloss/epiphany/close.c
--- newlib-1.20.0.orig/libgloss/epiphany/close.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/close.c	2012-03-28 10:11:12.206137859 +0200
@@ -0,0 +1,52 @@
+/* EPIPHANY implementation of _close ()
+
+   Copyright (c) 2011, 2012 Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+#include <errno.h>
+#include "epiphany-syscalls.h"
+
+/* ------------------------------------------------------------------------- */
+/*!Close an open file
+
+   When run with the simulator, asm_close () uses the host close routine,
+   otherwise it is up to the hardware to provide a suitable BSP
+   implementation. In either case it returns 0 on success or -1 on failure,
+   and updates errno on failure.
+
+   @param[in] filedes  The file descriptor to close
+
+   @return  0 on success, -1 on failure with an error code in errno.         */
+/* ------------------------------------------------------------------------- */
+int __attribute__ ((section ("libgloss_epiphany")))
+_close (int  fildes)
+{
+  return  asm_close (fildes);
+
+}	/* _close () */
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/config.h.in newlib-1.20.0/libgloss/epiphany/config.h.in
--- newlib-1.20.0.orig/libgloss/epiphany/config.h.in	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/config.h.in	2012-03-28 10:11:12.206137859 +0200
@@ -0,0 +1,31 @@
+/* config.h.in.  Generated from configure.in by autoheader.  */
+
+/* .pushsection/.popsection directives allowed */
+#undef HAVE_ASM_POPSECTION_DIRECTIVE
+
+/* .previous directive allowed */
+#undef HAVE_ASM_PREVIOUS_DIRECTIVE
+
+/* Using ELF format */
+#undef HAVE_ELF
+
+/* Using GNU ld */
+#undef HAVE_GNU_LD
+
+/* Define to the address where bug reports for this package should be sent. */
+#undef PACKAGE_BUGREPORT
+
+/* Define to the full name of this package. */
+#undef PACKAGE_NAME
+
+/* Define to the full name and version of this package. */
+#undef PACKAGE_STRING
+
+/* Define to the one symbol short name of this package. */
+#undef PACKAGE_TARNAME
+
+/* Define to the version of this package. */
+#undef PACKAGE_VERSION
+
+/* symbol prefix */
+#undef __SYMBOL_PREFIX
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/configure.in newlib-1.20.0/libgloss/epiphany/configure.in
--- newlib-1.20.0.orig/libgloss/epiphany/configure.in	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/configure.in	2012-03-28 10:11:12.210137922 +0200
@@ -0,0 +1,127 @@
+# Makefile for libgloss/epiphany
+
+# Copyright (c) 2011, Adapteva, Inc.
+# All rights reserved.
+
+# Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#  * Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#  * Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#  * Neither the name of Adapteva nor the names of its contributors may be
+#    used to endorse or promote products derived from this software without
+#    specific prior written permission.
+
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.                                               */
+
+# Process this file with autoconf to produce a configure script
+
+AC_PREREQ(2.59)
+AC_INIT(libepiphany,0.0.1)
+AC_CONFIG_HEADER(config.h)
+
+# No shared libraries allowed
+if test "${enable_shared}" = "yes" ; then
+    echo "Shared libraries not supported for cross compiling, ignored"
+fi
+
+# Where are the auxillary tools (confg.sub etc)?
+if test "$srcdir" = "." ; then
+  if test "${with_target_subdir}" != "." ; then
+    libgloss_topdir="${srcdir}/${with_multisrctop}../../.."
+  else
+    libgloss_topdir="${srcdir}/${with_multisrctop}../.."
+  fi
+else
+  libgloss_topdir="${srcdir}/../.."
+fi
+AC_CONFIG_AUX_DIR($libgloss_topdir)
+
+AC_CANONICAL_SYSTEM
+AC_ARG_PROGRAM
+
+AC_PROG_INSTALL
+
+AC_DEFINE(HAVE_GNU_LD, 1, [Using GNU ld])
+
+# We always use ELF, define various useful associated things.
+AC_DEFINE(HAVE_ELF, 1, [Using ELF format])
+
+# Assembler directives (the assembler handles them, whether it does anything
+# useful with them is another matter...
+AC_DEFINE(HAVE_ASM_PREVIOUS_DIRECTIVE, 1, [.previous directive allowed])
+AC_DEFINE(HAVE_ASM_POPSECTION_DIRECTIVE, 1,
+          [.pushsection/.popsection directives allowed])
+
+# Section attributes in C don't currently work
+#AC_DEFINE(HAVE_SECTION_ATTRIBUTES, 1, [support for section attributes])
+
+# Sort out what the symbol prefix is (we could just fix it as '_', but let the
+# script work it out.
+AC_CACHE_CHECK([for symbol prefix], libc_symbol_prefix, [dnl
+cat > conftest.c <<\EOF
+foo () { }
+EOF
+dnl
+libc_symbol_prefix=none
+if AC_TRY_COMMAND([${CC-cc} -S conftest.c -o - | fgrep "\$foo" > /dev/null]);
+then
+  libc_symbol_prefix='$'
+else
+  if AC_TRY_COMMAND([${CC-cc} -S conftest.c -o - | fgrep "_foo" > /dev/null]);
+  then
+    libc_symbol_prefix=_
+  fi
+fi
+rm -f conftest* ])
+if test $libc_symbol_prefix != none; then
+  AC_DEFINE_UNQUOTED(__SYMBOL_PREFIX, "$libc_symbol_prefix", [symbol prefix])
+else
+  AC_DEFINE(__SYMBOL_PREFIX, "", [symbol prefix])
+fi
+
+# Standard stuff copied from libnosys. For this we'll need to an aclocal.m4
+LIB_AC_PROG_CC
+AS=${AS-as}
+AC_SUBST(AS)
+AR=${AR-ar}
+AC_SUBST(AR)
+LD=${LD-ld}
+AC_SUBST(LD)
+AC_PROG_RANLIB
+LIB_AM_PROG_AS
+
+host_makefile_frag=${srcdir}/../config/default.mh
+
+dnl We have to assign the same value to other variables because autoconf
+dnl doesn't provide a mechanism to substitute a replacement keyword with
+dnl arbitrary data or pathnames.
+dnl
+host_makefile_frag_path=$host_makefile_frag
+AC_SUBST(host_makefile_frag_path)
+AC_SUBST_FILE(host_makefile_frag)
+
+AC_CONFIG_FILES(Makefile,
+ac_file=Makefile . ${libgloss_topdir}/config-ml.in,
+srcdir=${srcdir}
+target=${target}
+with_multisubdir=${with_multisubdir}
+ac_configure_args="${ac_configure_args} --enable-multilib"
+CONFIG_SHELL=${CONFIG_SHELL-/bin/sh}
+libgloss_topdir=${libgloss_topdir}
+)
+AC_OUTPUT
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/crt0.S newlib-1.20.0/libgloss/epiphany/crt0.S
--- newlib-1.20.0.orig/libgloss/epiphany/crt0.S	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/crt0.S	2012-03-28 10:11:12.210137922 +0200
@@ -0,0 +1,166 @@
+# C Startup for EPIPHANY
+
+# Copyright (c) 2011, Adapteva, Inc.
+# All rights reserved.
+
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions are met:
+#  * Redistributions of source code must retain the above copyright notice,
+#    this list of conditions and the following disclaimer.
+#  * Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#  * Neither the name of Adapteva nor the names of its contributors may be
+#    used to endorse or promote products derived from this software without
+#    specific prior written permission.
+
+# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+
+.section IVT,"a",@progbits     ;
+        .global _start;
+        .type   _start, %function;
+_start:
+		.balign 4 ;
+         b .normal_start
+
+        .balign 4 ; 0x4
+         b .sw_exception_v
+
+		.balign 4 ; 0x8
+         b .page_miss_v;
+
+		.balign 4 ; 0xc
+         b .timer0_expired_v
+
+		.balign 4 ; 0x10
+         b .timer1_expired_v
+
+		.balign 4 ; 0x14
+		b .message_v
+
+		.balign 4 ; 0x18
+		 b .dma0_v
+
+		.balign 4 ; 0x1c
+		 b .dma1_v
+
+		.balign 4 ; 0x20
+		 b .wand_v
+
+		.balign 4 ; 0x24
+		 b .soft_v
+
+.size  _start, .-_start
+
+.section RESERVED_CRT0,"a",@progbits     ;
+
+.global .normal_start;
+.balign 4
+.type   .normal_start, %function
+.normal_start:
+	mov  r3,%low(_external_start)
+	movt r3,%high(_external_start)
+	jalr r3
+.size  .normal_start, .-.normal_start
+
+
+
+
+.section .text;
+	.org    0x0000                  ; Relative to start of text section
+	.global _external_start
+	.type   _external_start, %function
+_external_start:
+
+	.align  4
+
+	;; Initialise the stack pointer and frame pointer. Hopefully __stack
+	;; is somewhere meaningful.
+	mov	sp,%low(___stack)
+	movt	sp,%high(___stack)
+	mov	fp,sp
+
+	;; Zero the data space
+	mov	r0,%low(___bss_start)
+	movt	r0,%high(___bss_start)
+	mov	r1,%low(_end)
+	movt	r1,%high(_end)
+	mov	r2,#0
+	mov	r3,#0
+.L0_init_:
+	strd	r2,[r0],+#1
+	sub	r5,r1,r0
+	bne	.L0_init_
+
+	;;  Setup destructors to be called from exit if main never returns
+#if 0
+	mov	r0,%low(fini)
+	movt	r0,%high(fini)
+	mov r2,%low(_atexit)
+	movt r2,%high(_atexit)
+	jalr r2
+#else
+	; calling atexit drags in malloc, so instead poke the function
+	; address directly into the reent structure
+	mov	r2,%low(__impure_ptr)
+	movt	r2,%high(__impure_ptr)
+	ldr	r2,[r2]
+	mov	r1,%low(fini)
+	movt	r1,%high(fini)
+#ifdef __STRUCT_ALIGN_64__
+#error
+	add	r2,r2,need_to_find_out; &_GLOBAL_REENT->atexit0
+	str	r2, [r2,-1];??or -2?; _GLOBAL_REENT->atexit
+	mov	r0, 1
+	str	r0, [r2,1]	; _GLOBAL_REENT->atexit0._ind
+	str	r1, [r2,2]	; _GLOBAL_REENT->atexit0._fns[0]
+#else  /* !__STRUCT_ALIGN_64__ */
+	add	r0,r2,0x14c	; &_GLOBAL_REENT->atexit0
+	str	r0, [r0,-1]	; _GLOBAL_REENT->atexit
+	mov	r0, 1
+	strd	r0, [r2,0x2a]	; _GLOBAL_REENT->atexit0._ind
+#endif /* !__STRUCT_ALIGN_64__ */
+#endif /* !0 */
+	;; Call global and static constructors
+	mov r2,%low(init)
+	movt r2,%high(init)
+	jalr r2
+
+
+	;;return from reset ISR
+	mov R0,%low(RDS)
+	movt R0,%high(RDS)
+	movts iret,r0
+	rti
+RDS:
+
+	;;  Initialise argc, argv and envp to empty and call main
+	mov	r0,#0
+	mov	r1,#0
+	mov	r2,#0
+	mov r3,%low(_main)
+	movt r3,%high(_main)
+	jalr r3
+	;;bl	_main
+
+	;; Call exit
+	mov r3,%low(_exit)
+	movt r3,%high(_exit)
+	jalr r3
+	;;bl	_exit
+
+	;; Should never reach here
+	idle
+
+.size   _external_start, .-_external_start
diff -Naur newlib-1.20.0.orig/libgloss/epiphany/environ.c newlib-1.20.0/libgloss/epiphany/environ.c
--- newlib-1.20.0.orig/libgloss/epiphany/environ.c	1970-01-01 01:00:00.000000000 +0100
+++ newlib-1.20.0/libgloss/epiphany/environ.c	2012-03-28 10:11:12.210137922 +0200
@@ -0,0 +1,37 @@
+/* EPIPHANY implementation of the environ vector
+
+   Copyright (c) 2011, Adapteva, Inc.
+   All rights reserved.
+
+   Contributor Jeremy Bennett <jeremy.bennett@embecosm.com> for Adapteva Inc
+
+   Redistribution and use in source and binary forms, with or without
+   modification, are permitted provided that the following conditions are met:
+    * Redistributions of source code must retain the above copyright notice,
+      this list of conditions and the following disclaimer.
+    * Redistributions in binary form must reproduce the above copyright
+      notice, this list of conditions and the following disclaimer in the
+      documentation and/or other materials provided with the distribution.
+    * Neither the name of Adapteva nor the names of its contributors may be
+      used to endorse or promote products derived from this software without
+      specific prior written permission.
+
+   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
+   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+   POSSIBILITY OF SUCH DAMAGE.                                               */
+
+
+/*!The empty list is suitable as a minimal implementation of the
+   environment. */
+char *__env[1] = { 0 };
+
+/*!Environment as a pointer to a pointer rather than a pointer to an array. */
+char **environ = __env;
